library si16help;
uses WinTypes,WinProcs,Messages,Sysutils;
{$R whver16.res}
var Helppath,Helpini: array [0..255] of Char;
	Helphandle: THandle;
{Exit variables:}
	SaveExit : pointer;
const ResKey : array [0..12] of Char = 'Variables';
{Cripplers}
var	Gotastring: Bool;
{CTL3D variables}
var	ThreeDTask: THandle; {Handle of Help instance}
	ThreeDModule : THandle;             { Handle of CTL3D.DLL }
	ErrorMode : Word;
	ThreeDReg, ThreeDAuto, ThreeDUnreg : pointer;
	Previnst: THandle;
	ThreeDDone: Bool;

{String vars}
type CString=Array[0..256] of char;
const  StringCount = 8;
var	StringBuffer : array[0..StringCount-1] of CString;
	StringIndex  : Integer;


function GetTempString : pchar;
Begin
   Inc(StringIndex);
   if (StringIndex >= StringCount) then StringIndex := 0;
   GetTempString:=PChar(@StringBuffer[StringIndex,0]);
End;


procedure YieldAppToDLL;
var MSG: TMsg;
	Handle: THandle;
begin
	Handle := 0;
	while PeekMessage(Msg,Handle, 0, 0, PM_REMOVE) = True do
		if(Msg.message = 18) then PostQuitMessage(0) else begin
			TranslateMessage(Msg);
			DispatchMessage(Msg);
		end;
end;

procedure SISInit(HPath: PChar;HHandle:Longint);Export;
var P1: array [0..255] of Char;
	DLLIni: String;
begin
{Has the helpfile been launched from an interfile link or
 has it been launched from a new instance of Help? If a new instance of Help,
 we will need to re-register CTL3D}
	If PrevInst <> Hhandle then begin
		Previnst := Hhandle;
		ThreeDdone := False;
	end else begin
		ThreeDdone := True;
	End;
	Helphandle := Hhandle;
	StrCopy(Helppath,HPath);
{Set up the INI file for use with this project}
	DLLIni := ChangeFileExt(ExpandFileName('SI16HELP.DLL'),'.INI');
	If FileExists(DLLIni) Then StrPCopy(Helpini,DLLIni) else
		StrPCopy(Helpini,ChangeFileExt(StrPas(HelpPath),'.INI'));
{Set up the instance tracker}
	If Previnst = 0 Then Previnst := Helphandle;
	Gotastring := False;
{3D registration}
	If ThreeDdone = False then begin
		ThreeDTask := GetWindowTask(Helphandle);
		ErrorMode := SetErrorMode(SEM_NOOPENFILEERRORBOX);
		ThreeDModule := LoadLibrary('CTL3DV2.DLL');
		if (ThreeDModule < HINSTANCE_ERROR) then ThreeDModule := LoadLibrary('CTL3D.DLL');
		if (ThreeDModule >= HINSTANCE_ERROR) then Begin
			ThreeDReg  := GetProcAddress(ThreeDModule,'Ctl3dRegister');
			ThreeDAuto := GetProcAddress(ThreeDModule,'Ctl3dAutoSubclass');
			ThreeDUnReg:= GetProcAddress(ThreeDModule,'Ctl3dUnRegister');
			if (ThreeDReg <> NIL) and (ThreeDAuto <> NIL) and (ThreeDUnReg <> NIL) then begin
				asm	Push ThreeDTask
					call ThreeDReg
					Push ThreeDTask
					Call ThreeDAuto
				End;
			End;
		End;{ctl3d init}
		ThreeDdone := True;
		SetErrorMode(ErrorMode); {restore normal errormode...now be sure ctl3d is in exitproc}
	End;
	YieldAppToDll;
end;
exports SISInit index 1;


function Is31:Bool;
var dwVersion           : longint;
   wWinVer    : WORD;
   WinVer: String;
begin
  dwVersion := GetVersion;
  wWinVer := LoWord(dwVersion);
  WinVer := IntToStr(LoByte(wWinVer)) + IntToStr(HiByte(wWinVer));
  If (StrToInt(WinVer) > 301) and (StrToInt(WinVer) < 340) Then Is31 := True Else Is31 := False;
end;



function WHGetColorDepth(AskedParam: Integer): Bool; Export;
var DCon: hDc;
begin
	DCon := GetDeviceCaps(GetDC(GetActiveWindow), BITSPIXEL);
	WHGetColorDepth := False;
	If AskedParam <= DCon Then WHGetColorDepth := True;
	ReleaseDC(GetActiveWindow,GetDC(GetActiveWindow));
	YieldAppToDll;
end;
exports WHGetColorDepth index 2;

function WHGCD(AskedParam: Integer): Bool; Export;
begin WHGCD := WHGetColorDepth(Askedparam); end;
exports WHGCD index 3;



Function WHMessageBox (wnd : Longint; messagecaption : PChar; messagetext: PChar; messageflags: Integer) : Boolean; Export;
var	messagestring: string;
	Tildeval: integer;
begin
	Messagestring := StrPas(Messagetext);
	While Pos('~~',Messagestring) <> 0 do begin
		Tildeval := Pos('~~',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(10),messagestring,TildeVal);
		end;
	StrPCopy(messagetext,messagestring);
	case MessageBox (GetActiveWindow, messagecaption, messagetext, messageflags) of
		idOK, idYes, idRetry : WHMessageBox:= True;
		idCancel, idAbort, idNo, idIgnore : WHMessageBox:= False;
	end;
end;
exports WHMessageBox index 4;
Function WHMB (wnd : Longint; messagecaption : PChar; messagetext: PChar; messageflags: Integer) : Boolean; Export;
begin
	WHMB := WHMessageBox (wnd, messagecaption, messagetext, messageflags)
end;
exports WHMB index 5;



procedure WHWritePrivateProfileString(ApplicationName, KeyName, Str,
  FileName: PChar); Export;
Begin
	 WritePrivateProfileString(ApplicationName, KeyName, Str, FileName);
end;
exports WHWritePrivateProfileString index 6;

procedure WHWPPS(ApplicationName, KeyName, Str, FileName: PChar); Export;
Begin
	 WritePrivateProfileString(ApplicationName, KeyName, Str, FileName)
end;
exports WHWPPS index 7;



function WHIfPrivateProfileString(Section, KeyName, Str,
	FileName: PChar): Bool; Export;
var ReturnedString: array[0..255] of Char;
begin
	GetPrivateProfileString(section,
		keyname, '', ReturnedString, SizeOf(ReturnedString), FileName);
  If StrPas(Str) = StrPas(ReturnedString) Then WHIfPrivateProfileString := True
  Else WHIfPrivateProfileString := False;
end;
exports WHIfPrivateProfileString index 8;

function WHIPPS(Section, KeyName, Str, FileName: PChar): Bool; Export;
begin
	WHIPPS := WHIfPrivateProfileString(Section, KeyName, Str, FileName);
end;
exports WHIPPS index 9;



function WHIfSecondary:Bool;Export;
var p1: array [0..99] of Char;
begin
	Getclassname(GetActiveWindow,P1,SizeOf(P1));
	If StrPas(P1) = 'MS_WINTOPIC_SECONDARY' Then WHIfSecondary := True Else WHIfSecondary := False;
end;
exports WHIfSecondary index 10;
function WHIS:Bool;Export;
begin WHIS := WHIfSecondary; end;
exports WHIS index 11;


procedure WHSetClipboardData(Cliptext: PChar); Export;
var	hLoc: THandle;
var c2: array [0..255] of Char;
var	Messagestring: string;
	Tildeval: integer;
begin
	Messagestring := StrPas(ClipText);
	While Pos('~~',Messagestring) <> 0 do begin
		Tildeval := Pos('~~',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(10),messagestring,TildeVal);
	end;
	While Pos('^^',Messagestring) <> 0 do begin
		Tildeval := Pos('^^',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(13) + Chr(10),messagestring,TildeVal);
	end;
	StrPCopy(C2,MessageString);
	If EmptyClipboard = False then CloseClipboard;
	If OpenClipboard(GetActiveWindow) = True Then Begin
		hLoc := GlobalAlloc( GHND, SizeOf(C2) + 1);
		strcopy(GlobalLock(hLoc), C2);
		GlobalUnlock( hLoc );
		SetClipboardData( CF_TEXT, hLoc );
		CloseClipboard;
	YieldAppToDll;
	end;
end;
exports WHSetClipboardData index 12;
procedure WHSCD(Cliptext: PChar); Export;
begin
	WHSetClipboardData(Cliptext);
end;
exports WHSCD index 13;


function FileExist(filename:pchar): Bool;Export;
var rec : TOfStruct;
	opts: Integer;
begin
(*	If (StrScan(Filename,'\') = nil) or (StrScan(Filename,'/') = nil) then
		opts := 1024{OF_SEARCH} else opts := OF_EXIST<0; *)
	If OpenFile(Filename, rec, opts) < 0 Then
	FileExist := False Else FileExist := True;
	YieldAppToDll;
end;
exports FileExist index 17;

function FE(filename:pchar):Bool;Export;
begin
	FE := FileExist(filename);
end;
exports FE index 18;


function WHGetPrivateProfileString(Section,Keyname,INIFile:PChar):Pointer;Export;
var	PCString : PChar;
begin
	PCString:=GetTempString;
	If Gotastring = False then begin
		GetPrivateProfileString(Section,Keyname,'',PCString,SizeOf(CString),INIFile);
		Gotastring := True;
	end;
	WHGetPrivateProfileString := PCString;
	YieldApptoDll;
end;
exports WHGetPrivateProfileString index 41;
function WHGPPS(Section,Keyname,INIFile:PChar):Pointer;Export;
begin
	WHGPPS := WHGetPrivateProfileString(Section,Keyname,INIFile);
end;
exports WHGPPS index 42;


function WHMessageBoxEnhanced(St1,St2,St3,St4,St5,St6,Cap:PChar;
	Flags:Integer):Bool;Export;{$IFDEF WIN32} StdCall; {$ENDIF}
var Pc1: array [0..1500] of Char;
	temP1,P1,P2,P3,P4,P5,P6: array [byte] of Char;
	i1: integer;
const MsgKey: array [0..10] of Char = 'Messages';

	function FatValidate(MessageString:String):String;
	var Tildeval: Byte;
	begin
		While Pos('~~',Messagestring) <> 0 do begin
			Tildeval := Pos('~~',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(Chr(10),messagestring,TildeVal);
		end;
		While Pos('>>',Messagestring) <> 0 do begin
			Tildeval := Pos('>>',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(' ',messagestring,TildeVal);
		end;
		Result := Messagestring;
	end;

begin
	If StrPas(St1) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P1,FatValidate(StrPas(temP1)));
		lstrcpy(@Pc1,P1);
	end else lstrcpy(@Pc1,'');
	If StrPas(St2) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St2,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P2,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P2);
	end;
	If StrPas(St3) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St3,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P3,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P3);
	end;
	If StrPas(St4) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St4,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P4,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P4);
	end;
	If StrPas(St5) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St5,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P5,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P5);
	end;
	If StrPas(St6) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St6,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P6,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P6);
	end;
{Null string?}
	StrPCopy(P1,Pc1[0] + Pc1[1] + Pc1[2]);
	If Length(StrPas(P1)) < 2 then begin
		StrPCopy(P1,'No message entries found...this software may require '
			+'reinstallation to repair a damaged .INI file.');
		lstrcpy(@Pc1,P1);
	end;
{Generate a messagebox}
	case MessageBox (GetActiveWindow,Pc1,Cap,Flags) of
		idOK, idYes, idRetry : Result := True;
		idCancel, idAbort, idNo, idIgnore : Result:= False;
	end;
	YieldAppTodll;
end;
exports WHMessageBoxEnhanced index 55;
function WHMBE(St1,St2,St3,St4,St5,St6,Cap:PChar;
	Flags:Integer):Bool;Export;{$IFDEF WIN32} StdCall; {$ENDIF}
begin
	Result := WHMessageBoxEnhanced(St1,St2,St3,St4,St5,St6,Cap,Flags);
end;
exports WHMBE index 56;


procedure WHGlobalCompact(Amount: LongInt); Export;
begin GlobalCompact(Amount) end;
exports WHGlobalCompact index 19;


{***************IMPLEMENTATION*****************}
procedure DLLExitProc; far;
begin
	ExitProc := SaveExit;
	if (ThreeDModule >= HINSTANCE_ERROR) then begin
		asm Push ThreeDTask
			call ThreeDUnReg
		end;
		FreeLibrary(ThreeDModule);
	end;
end;

begin
  SaveExit := ExitProc;
  ExitProc := @DLLExitProc;
end.


